#if !defined  HAVE_PERMRAND_CONNECTED_H__
#define       HAVE_PERMRAND_CONNECTED_H__


#include "perm/permrand.h"
#include "perm/permq.h"
#include "aux0/swap.h"
#include "aux0/rand-idx.h"
#include "fxttypes.h"


inline void random_connected_permutation(ulong *f, ulong n)
// Create a random connected (indecomposable) permutation.
{
    if ( n<=3 )
    {
        for (ulong k=0; k<n; ++k)  f[k] = k;
        if ( n<2 )  return;   // [] or [0]
        swap2(f[0], f[n-1]);
        if ( n==2 )  return;  // [1,0]
        // here: [2,1,0]
        const ulong i = rand_idx(3);
        swap2(f[1], f[i]);
        // i = 0  ==>  [1,2,0]
        // i = 1  ==>  [2,1,0]
        // i = 2  ==>  [2,0,1]
        return;
    }

#if 0  // need to repeat once in 2/n times:
    for (ulong k=0; k<n; ++k)  f[k] = k;
    do  { random_permute(f, n); }  while ( ! is_connected(f, n) );

#else  // need to repeat once in 1/n^2 times:
    do
    {
        for (ulong k=0; k<n; ++k)  f[k] = k;
        swap2( f[0], f[1+rand_idx(n-1)] );  // first element cannot stay
        swap2( f[n-1], f[rand_idx(n-1)] );  // last element cannot stay
        random_permute(f+1, n-2);  // permute 2nd to 2nd last
    }
    while ( ! is_connected(f, n) );
#endif
}
// -------------------------


#endif  // !defined HAVE_PERMRAND_CONNECTED_H__
